# [0.10.0] - 2019-05-13

## Added

- [ISSUE-223](https://github.com/tartiflette/tartiflette/issues/223) Now support directives on Scalar, Object, InputObject, Enum, EnumValue.

Two new static methods have been added to the `OnExecutionDirective` class

```python
@staticmethod
async def on_pre_output_coercion(directive_args, next_directive, value, field_definition, ctx, info):
    return await next_directive(value, field_definition, ctx, info)

@staticmethod
async def on_post_input_coercion(directive_args, next_directive, value, argument_definition, ctx, info):
    return await next_directive(value, argument_definition, ctx, info)
```
>Warning: Please test your resolvers/SDL with this lib before going for it. The execution alorigthm changed, it may still have bugs lingering

Have a look at the updated [Tatiflette documentation](https://tartiflette.io/docs/api/directive) for more details.

## Changed

- Introspection directives are now async.
>Warning: This is an API breaking change for your directives. Built-ins have been updated

Before:
```python
@staticmethod
def on_introspection(
    directive_args: Dict[str, Any],
    next_directive: Callable,
    introspected_element: Any,
    ctx: Optional[Dict[str, Any]],
    info: "Info",
) -> Any:
    """
    Hook allowing you to alterate the introspection behavior for an
    element.
    :param directive_args: arguments passed to the directive
    :param next_directive: next directive to call
    :param introspected_element: current introspected element
    :param ctx: context passed to the query execution
    :param info: information related to the execution & field resolve
    :return: Any
    """
    # pylint: disable=unused-argument
    return next_directive(introspected_element, ctx, info)
```

Now:
```python
@staticmethod
async def on_introspection(
    directive_args: Dict[str, Any],
    next_directive: Callable,
    introspected_element: Any,
    ctx: Optional[Dict[str, Any]],
    info: "Info",
) -> Any:
    """
    Hook allowing you to alterate the introspection behavior for an
    element.
    :param directive_args: arguments passed to the directive
    :param next_directive: next directive to call
    :param introspected_element: current introspected element
    :param ctx: context passed to the query execution
    :param info: information related to the execution & field resolve
    :return: Any
    """
    # pylint: disable=unused-argument
    return await next_directive(introspected_element, ctx, info)
```

## Fixed

- Built-in `deprecated` introspection directive weren't calling its next directive properly.

